// fft.h: interface for the Cxfft class.
//
//  This is a sone what modified version of Takuya OOURA's
//     original radix 4 FFT package.
//Copyright(C) 1996-1998 Takuya OOURA
//    (email: ooura@mmm.t.u-tokyo.ac.jp).
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XFFT_H__C6E9A1D3_2D5F_11D3_A208_00A0C996E7F5__INCLUDED_)
#define AFX_XFFT_H__C6E9A1D3_2D5F_11D3_A208_00A0C996E7F5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MAX_FFT_SIZE 0x80000
#define MIN_FFT_SIZE 0x400
#define MAX_PLOT_SIZE 4096

class Cxfft  
{
public:
	void SetFFTParams( BOOL Complex, long size, long ave,
						BOOL invert, double dBCompensation, 
						double IQoffset, long SampleFreq);
	void ResetFFT();
	BOOL GetDoubleFFTData(long start, long stop, double* OutBuf );
	BOOL GetScreenIntegerFFTData(long MaxHeight, long MaxWidth,
									double MaxdB, double MindB,
									long StartFreq, long StopFreq,
									long* OutBuf );
	long PutInFFT(short* InBuf);
	Cxfft();
	virtual ~Cxfft();
private:
	void FreeMemory();
	void makewt(int nw, int *ip, double *w);
	void makect(int nc, int *ip, double *c);
	void bitrv2(int n, int *ip, double *a);
	void cftfsub(int n, double *a, double *w);
	void rftfsub(int n, double *a, int nc, double *c);
	void CpxFFT(int n, double *a, double *w);
	void cft1st(int n, double *a, double *w);
	void cftmdl(int n, int l, double *a, double *w);

	BOOL m_Complex;
	BOOL m_LastComplex;
	BOOL m_Overload;
	BOOL m_Invert;
	long m_AveCount;
	long m_TotalCount;
	long m_LastAve;
	long m_FFTSize;
	long m_LastFFTSize;
	long m_AveSize;
	long m_StartFreq;
	long m_StopFreq;
	long m_BinMin;
	long m_BinMax;
	long m_PlotWidth;

	double m_K_C;
	double m_K_B;
	double m_dBCompensation;
	double m_SampleFreq;
	double m_IQoffset;
	int* pWorkArea;
	int* m_pTranslateTbl;
	double* pSinCosTbl;
	double* pWindowTbl;
	double* pFFTPwrAveBuf;
	double* pFFTAveBuf;
	double* pFFTSumBuf;
	double* pFFTInBuf;
	CRITICAL_SECTION m_CriticalSection;	//for keeping threads from stomping on each other
};

#endif // !defined(AFX_XFFT_H__C6E9A1D3_2D5F_11D3_A208_00A0C996E7F5__INCLUDED_)
